markup.push({

	"Toolbar": {
        nsClass: "GXSettingsView",
        gxBackPainter: "WindowTitleBarBack",
        gxIntrinsicWidth: -1,
        gxCanDrawSubviewsIntoLayer: true,    // important for drawn text quality of labels on our gradient background
		gxLayout: [
			"V:[self]-(<=0)-[lcd]&alignCenterX",
			"H:|-240-[lcd]-240-|",
			"V:|-0-[lcd]-0-|",
			"V:|-5-[grid]",		// set distance from top for all of the buttons
			// horizontally space most buttons, and align vertically
            "H:|-95-[hideSets(30)]-30-[grid(30)]-0-[list(30)]-(>=0)-[new(30)]-50-[hideInspector(30)]-32-|&alignCenterY",
			// place labels centered under controls
			"V:[grid]-0-[gridLabel]&alignCenterX",
			"V:[list]-0-[listLabel]&alignCenterX",
			"V:[new]-0-[newLabel]&alignCenterX",
			"V:[hideInspector]-0-[hideInspectorLabel]&alignCenterX",
			"V:[hideSets]-0-[hideSetsLabel]&alignCenterX",
		],
		gxChildViews: {
			//"trialButton": "TrialButton",
			"new": {
				"+": "IconBarButton",
				gxValueKeyPath : "newButton",
				gxForePainter: "ImagePainter.tintDark.newIcon",
                axTitle: "New Tile",
                axHelp: "Select an audio file to add as a new tile.",
			},
			"grid": {
				"+": "IconBarButton.toggle.leftSegment",
				gxValueKeyPath : "gridButton",
				gxForePainter: "ImagePainter.tintDark.invertOn.gridIcon",
                axTitle: "Grid Layout",
                axHelp: "Lay tiles out in a grid.",
			},
			"list": {
				"+": "IconBarButton.toggle.rightSegment",
				gxValueKeyPath : "listButton",
				gxForePainter: "ImagePainter.tintDark.invertOn.listIcon",
                axTitle: "List Layout",
                axHelp: "Lay tiles out in a list.",
			},
			"hideSets": {
				"+": "IconBarButton",
				gxValueKeyPath : "hideSetsList",
				gxForePainter: "ImagePainter.tintDark.hideSets",
                gxTitleKeyPath : "hideSetsListText",
                axHelp: "Hide or Show the Sets list",
			},
			"hideInspector": {
				"+": "IconBarButton",
				gxValueKeyPath : "hideInspector",
				gxForePainter: "ImagePainter.tintDark.hideInspector",
                gxTitleKeyPath : "hideInspectorText",
                axHelp: "Hide or Show the Tile Inspector",
			},
			"gridLabel": {
				"+": "LabelView.centerx.secondary.size10",
				gxDefaultValue: "Grid"
			},
			"listLabel": {
				"+": "LabelView.centerx.secondary.size10",
				gxDefaultValue: "List"
			},
			"newLabel": {
				"+": "LabelView.centerx.secondary.size10",
				gxDefaultValue: "Add Sound"
			},
			"hideSetsLabel": {
				"+": "LabelView.centerx.secondary.size10",
				gxIntrinsicWidth: 60,
				gxValueKeyPath : "hideSetsListText",
			},
			"hideInspectorLabel": {
				"+": "LabelView.centerx.secondary.size10",
				gxIntrinsicWidth: 80,
				gxValueKeyPath : "hideInspectorText",
			},
			"lcd": { "+": "LCD", gxIntrinsicWidth: -1 },
		},

	},

	// MARK: - button template

	"ImageBarButton": {  // images without border
		nsClass: "GXButtonView",
		gxIntrinsicHeight: 24,
		gxIntrinsicWidth: 24,
	},

	"IconBarButton": {  // images in a button frame
		nsClass: "GXButtonView",
		gxIntrinsicHeight: 24,
		gxIntrinsicWidth: 30,
		gxBackPainter: "IconBarButtonBack",
	},

	"IconBarButtonBack": {
		nsClass: "GXRoundRectPainter",
		gxCornerRadii: "4, 4, 4, 4",
		gxEdgeInsets: "2,2,2,2",
		gxFillColor: "name:toolbarButton",
		gxFrameColor: "name:toolbarButton",
        //gxFrameColor: "name:disabled",
		gxShadow: "{0.0, 0.0, 0.0 0.7}, {0.0, -0.25}, 1.5", 
		"leftSegment": {
			gxCornerRadii: "5, 0, 0, 5",
            gxEdgeInsets: "2,2,0,2",
			gxIntrinsicWidth: 28,
		},
		"rightSegment": {
			gxCornerRadii: "0, 5, 5, 0",
            gxEdgeInsets: "0,2,2,2",
			gxIntrinsicWidth: 28,
		},
		/*"pressed" : {
			gxFillColor: "name:tertiary",
            gxFrameColor: "name:tertiary",
			//gxFrameColor: "name:primary",
		},
		"toggleFill" : {
			"on" : {
				gxFillColor: "name:primary",
                gxFrameColor: "name:primary",
				//gxFrameColor: "name:secondary",
			},
		},
		"disabled" : {
			gxFillColor: "name:white",
            gxFrameColor: "name:white",
			"on" : {
				gxFillColor: "name:disabled",
                gxFrameColor: "name:disabled",
			}
		}*/
	},

});
